import Vue from 'vue'
import VueRouter from 'vue-router'
import Search from "@/views/Search.vue";
import Home from "@/views/Home.vue";
import TrainingCompletion from "@/views/TrainingCompletion.vue";
import FallPrevention from "@/views/FallPrevention.vue";
import store from '@/store/index';

Vue.use(VueRouter)

const routes = [
    {
        path: '/',
        name: 'Search',
        component: Search,
    },
    {
        path: '/home',
        name: 'Home',
        component: Home,

        beforeEnter: (to: any, from: any, next: any) => {
            if (!store.state.search) {
                store.watch(
                    (state) => state.search,
                    (value) => {
                        value == false ? next(false) : next();
                    }
                )
            }
        },

        redirect: {
            name: 'Training Completion'
        },
        children: [
            {
                name: 'Training Completion',
                path: '/trainingcompletion',
                component: TrainingCompletion,
                // route level code-splitting
                // this generates a separate chunk (about.[hash].js) for this route
                // which is lazy-loaded when the route is visited.
                // component: () => import(/* webpackChunkName: "about" */ '../views/TrainingCompletion')
            },
            {
                name: 'Fall Prevention',
                path: '/fallprevention',
                component: FallPrevention,
                // route level code-splitting
                // this generates a separate chunk (about.[hash].js) for this route
                // which is lazy-loaded when the route is visited.
                // component: () => import(/* webpackChunkName: "about" */ '../views/FallPrevention.vue')
            }
        ]
    },
]

const router = new VueRouter({
    mode: 'history',
    base: process.env.BASE_URL,
    routes
})

export default router
