import http from "../http-common";
import store from "../store/index";

class DataService {
  async fetchCitizenInformationBasedOnSSN(citizenSSN: any): Promise<Boolean> {
    const citizenData = await http.post('home/:ssn', { citizenSSN });
    if (citizenData.data == '') {
      return false;
    } else {
      this.setCitizenInformation(citizenData)
      return true;
    }
  }

  //All data has to be managed and stored from here (Exception Handling)
  setCitizenInformation(citizenInformation: any) {
    store.dispatch("citizenProfile", [
      citizenInformation.data.citizenData.first_name,
      citizenInformation.data.citizenData.last_name,
      citizenInformation.data.citizenData.age,
      citizenInformation.data.citizenData.ssn
    ]);
    store.dispatch("trainingPlans", citizenInformation.data.citizenData.Training_Plans);
    store.dispatch("homeCare", citizenInformation.data.citizenData.Home_Care);
    store.dispatch("registeredFalls", citizenInformation.data.citizenData.Registered_Falls);

    store.dispatch("probabilityComplete", citizenInformation.data.predictionFromML.CompleteProb);
    store.dispatch("probabilityFall", citizenInformation.data.predictionFromML.FallProb);
    store.dispatch("compliance", citizenInformation.data.predictionFromML.ComplianceProb);
    store.dispatch("arguments", citizenInformation.data.predictionFromML.Arguments);
    store.dispatch("shapComplete", citizenInformation.data.predictionFromML.CompleteShapValues);
    store.dispatch("shapFall", citizenInformation.data.predictionFromML.FallShapValues);
  }
}

export default new DataService();
